

import java.awt.EventQueue;

import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JSeparator;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.JTable;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.SSLClient.TSBCertificateNeededExEvent;
import SecureBlackbox.SSLCommon.SBSSLConstants;
import SecureBlackbox.SSLCommon.TSBCertificateValidateEvent;
import SecureBlackbox.SSLCommon.TSBErrorEvent;
import SecureBlackbox.SSLCommon.TSBSSLMode;
import SecureBlackbox.FTPSClient.*;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FileInputStream;
import java.util.Date;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class Main extends JDialog {
	private static final long serialVersionUID = 1L;
	private JTextField tbCommand;
	private JTable tableLog;

	private TElX509Certificate Cert;
	private TElSimpleFTPSClient Client;
	
	private TElWinCertStorage ElWinCertStorage;
	
	private boolean FUseCert;
	private int FNeededIndex;

	private final String sNotConnected = "You are not connected. Use Connect command first.";
	private final String sNoParameter = "Command parameter not specified";
	private TElX509CertificateValidator CertificateValidator;
	private JTextPane editOutput;
	private TElMemoryCertStorage ElMemoryCertStorage;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				onDisconnectClick();
				Cert.Destroy();
				CertificateValidator.Destroy();
				ElMemoryCertStorage.Destroy();
				System.exit(0);
			}
		});		
		setTitle("Simple FTPS Client");
		setBounds(100, 100, 666, 691);
		getContentPane().setLayout(null);
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		
		JMenuBar menuBar = new JMenuBar();
		menuBar.setBounds(0, 0, 658, 21);
		getContentPane().add(menuBar);
		
		JMenu mnConnection = new JMenu("Connection");
		menuBar.add(mnConnection);
		
		JMenuItem mntmConnect = new JMenuItem("Connect");
		mntmConnect.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				onConnectClick();
			}
		});
		mnConnection.add(mntmConnect);
		
		JMenuItem mntmDisconnect = new JMenuItem("Disconnect");
		mntmDisconnect.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				onDisconnectClick();
			}
		});
		mnConnection.add(mntmDisconnect);
		
		JSeparator separator = new JSeparator();
		mnConnection.add(separator);
		
		JMenuItem mntmExit = new JMenuItem("Exit");
		mntmExit.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				onDisconnectClick();
				dispose();
			}
		});
		mnConnection.add(mntmExit);
		
		JMenu mnHelp = new JMenu("Help");
		menuBar.add(mnHelp);
		
		JMenuItem mntmAbout = new JMenuItem("About");
		mntmAbout.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				AboutDialog dlg = new AboutDialog();
				dlg.setModal(true);
				dlg.setVisible(true);
			}
		});
		mnHelp.add(mntmAbout);
		
		JPanel panel = new JPanel();
		panel.setBorder(new EtchedBorder(EtchedBorder.RAISED, null, null));
		panel.setBounds(0, 21, 658, 158);
		getContentPane().add(panel);
		panel.setLayout(null);
		
		JButton btnConnect = new JButton("Connect");
		btnConnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onConnectClick();
			}
		});
		btnConnect.setBounds(10, 11, 91, 23);
		panel.add(btnConnect);
		
		JButton btnPwd = new JButton("PWD");
		btnPwd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onPWDClick();
			}
		});
		btnPwd.setBounds(10, 45, 91, 23);
		panel.add(btnPwd);
		
		JButton btnDownload = new JButton("Download");
		btnDownload.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onDownloadClick();
			}
		});
		btnDownload.setBounds(10, 79, 91, 23);
		panel.add(btnDownload);
		
		JButton btnDisconnect = new JButton("Disconnect");
		btnDisconnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onDisconnectClick();
			}
		});
		btnDisconnect.setBounds(112, 11, 102, 23);
		panel.add(btnDisconnect);
		
		JButton btnCwd = new JButton("CWD");
		btnCwd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onCWDClick();
			}
		});
		btnCwd.setBounds(111, 45, 103, 23);
		panel.add(btnCwd);
		
		JButton btnUpload = new JButton("Upload");
		btnUpload.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onUploadClick();
			}
		});
		btnUpload.setBounds(111, 79, 103, 23);
		panel.add(btnUpload);
		
		JButton btnCdup = new JButton("CDUp");
		btnCdup.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onCDUpClick();
			}
		});
		btnCdup.setBounds(224, 45, 102, 23);
		panel.add(btnCdup);
		
		JButton btnDeleteFile = new JButton("Delete File");
		btnDeleteFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onDeleteFileClick();
			}
		});
		btnDeleteFile.setBounds(224, 79, 102, 23);
		panel.add(btnDeleteFile);
		
		JButton btnListDir = new JButton("List Dir");
		btnListDir.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onListClick();
			}
		});
		btnListDir.setBounds(336, 45, 91, 23);
		panel.add(btnListDir);
		
		JButton btnCreateDir = new JButton("Create Dir");
		btnCreateDir.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onMKDirClick();
			}
		});
		btnCreateDir.setBounds(437, 45, 91, 23);
		panel.add(btnCreateDir);
		
		JButton btnRemoveDir = new JButton("Remove Dir");
		btnRemoveDir.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onRemoveClick();
			}
		});
		btnRemoveDir.setBounds(538, 45, 102, 23);
		panel.add(btnRemoveDir);
		
		JLabel lblCommandParameter = new JLabel("Command parameter:");
		lblCommandParameter.setBounds(10, 122, 138, 14);
		panel.add(lblCommandParameter);
		
		tbCommand = new JTextField();
		tbCommand.setBounds(158, 119, 482, 20);
		panel.add(tbCommand);
		tbCommand.setColumns(10);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(0, 185, 658, 354);
		getContentPane().add(scrollPane);
		
		editOutput = new JTextPane();
		scrollPane.setViewportView(editOutput);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(0, 542, 658, 122);
		getContentPane().add(scrollPane_1);
		
		tableLog = new JTable(new LogTableModel());
		tableLog.setFillsViewportHeight(true);
		scrollPane_1.setViewportView(tableLog);

		init();
	}

	protected void onUploadClick() {
		TElFileStream DataStream;
		
		if (Client.getActive())
		{
			if (tbCommand.getText().trim().length() == 0)
			{
				showMessage(sNoParameter);
				return;
			}
			String fileName = getOpenFileName();
			if (fileName.compareTo("") != 0)
			{
				DataStream = new TElFileStream(fileName, "r", true);
				try
				{
                    FNeededIndex = 0;
					Log("Sending file...", false);
					Client.send(DataStream, tbCommand.getText().trim(), 0, DataStream.getLength() - 1, false, 0);					
					Log("File sent", false);
				}
				catch (Exception E)
				{
					Log(E.getMessage(), true);
				}
				finally
				{
					DataStream.Free();
				}
			}
		}
		else
			Log(sNotConnected, false);
	}

	String getOpenFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

		return tbCommand.getText();
	} 

	protected void onDownloadClick() {
		TElFileStream DataStream;
		
		if (Client.getActive())
		{
			if (tbCommand.getText().trim().length() == 0)
			{
				showMessage(sNoParameter);
				return;
			}
			String fileName = getSaveFileName();
			if (fileName.compareTo("") != 0)
			{
				DataStream = new TElFileStream(fileName, "rw", true);
				try
				{
                    FNeededIndex = 0;
					Log("Receiving file...", false);
					Client.receive(tbCommand.getText().trim(), DataStream);					
					Log("File received", false);
				}
				catch (Exception E)
				{
					Log(E.getMessage(), true);
				}
				finally
				{
					DataStream.Free();
				}
			}
		}
		else
			Log(sNotConnected, false);
	}

	String getSaveFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

		return tbCommand.getText();
	} 

	protected void onDeleteFileClick() {
		if (Client.getActive())
		{
			if (tbCommand.getText().trim().length() == 0)
			{
				showMessage(sNoParameter);
				return;
			}
			try
			{
				Log("Removing file...", false);
				Client.delete(tbCommand.getText().trim());					
				Log("File removed", false);
			}
			catch (Exception E)
			{
				Log(E.getMessage(), true);
			}
		}
		else
			Log(sNotConnected, false);		
	}

	protected void onRemoveClick() {
		if (Client.getActive())
		{
			if (tbCommand.getText().trim().length() == 0)
			{
				showMessage(sNoParameter);
				return;
			}
			try
			{
				Log("Removing directory...", false);
				Client.removeDir(tbCommand.getText().trim());					
				Log("Directory removed", false);
			}
			catch (Exception E)
			{
				Log(E.getMessage(), true);
			}
		}
		else
			Log(sNotConnected, false);		
	}

	protected void onMKDirClick() {
		if (Client.getActive())
		{
			if (tbCommand.getText().trim().length() == 0)
			{
				showMessage(sNoParameter);
				return;
			}
			try
			{
				Log("Creating directory...", false);
				Client.makeDir(tbCommand.getText().trim());					
				Log("Directory created", false);
			}
			catch (Exception E)
			{
				Log(E.getMessage(), true);
			}
		}
		else
			Log(sNotConnected, false);		
	}

	protected void onListClick() {
		if (Client.getActive())
		{
			try
			{
                FNeededIndex = 0;
				Log("Listing directory...", false);
				Client.getFileList();
				Log("Directory list retrieved", false);
			}
			catch (Exception E)
			{
				E.printStackTrace();
				Log(E.getMessage(), true);
			}
		}
		else
			Log(sNotConnected, false);
	}

	protected void onCDUpClick() {
		if (Client.getActive())
		{
			try
			{
				Log("Changing directory...", false);
				Client.cdUp();
				Log("Directory changed. Current directory is: " + Client.getCurrentDir(), false);
			}
			catch (Exception E)
			{
				Log(E.getMessage(), true);
			}
		}
		else
			Log(sNotConnected, false);
	}

	protected void onCWDClick() {
		if (Client.getActive())
		{
			if (tbCommand.getText().trim().length() == 0)
			{
				showMessage(sNoParameter);
				return;
			}
			try
			{
				Log("Changing directory...", false);
				Client.cwd(tbCommand.getText().trim());
				Log("Directory changed. Current directory is: " + Client.getCurrentDir(), false);
			}
			catch (Exception E)
			{
				Log(E.getMessage(), true);
			}
		}
		else
			Log(sNotConnected, false);
	}

	protected void onPWDClick() {
		if (Client.getActive())
		{
			try
			{
				editOutput.setText(editOutput.getText() + "Current directory is: " + Client.getCurrentDir() + "\n");
			}
			catch (Exception E)
			{
				Log(E.getMessage(), true);
			}
		}
		else
			Log(sNotConnected, false);
	}

	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
		ElMemoryCertStorage = new TElMemoryCertStorage();
		Cert = new TElX509Certificate();
		Client = new TElSimpleFTPSClient();
		CertificateValidator = new TElX509CertificateValidator();
		
        // Initialize SecureBlackbox JNI library. sbbjni32.dll and sbbjni64.dll must be located in java.library.path
        // You can also call JNI.initialize("full_path_to_dll") method.
        JNI.initialize();
		
		ElWinCertStorage = new TElWinCertStorage();		
		ElWinCertStorage.setAccessType(TSBStorageAccessType.atCurrentUser);
		ElWinCertStorage.setOptions((short)(1));
		ElWinCertStorage.setProvider(TSBStorageProviderType.ptDefault);
		ElWinCertStorage.setStorageType(TSBStorageType.stSystem);
		ElWinCertStorage.setTryCurrentUser(true);
		
		Client.setCertStorage(ElWinCertStorage);
		
		initEvents();
	}

	private void initEvents() {
		Client.setOnTextDataLine(new TSBFTPSTextDataEvent(onTextDataLine));
		Client.setOnSSLError(new TSBErrorEvent(onSSLError));
		Client.setOnControlReceive(new TSBFTPSTextDataEvent(onControlReceive));
		Client.setOnCertificateNeededEx(new TSBCertificateNeededExEvent(onCertificateNeededEx));
		Client.setOnControlSend(new TSBFTPSTextDataEvent(onControlSend));
		Client.setOnCertificateValidate(new TSBCertificateValidateEvent(onCertificateValidate));		
	}
	
	TSBCertificateValidateEvent.Callback onCertificateValidate = new TSBCertificateValidateEvent.Callback() {
		
		public void tsbCertificateValidateEventCallback(TObject sender,
				TElX509Certificate Certificate, TSBBoolean accept) {
			
			accept.value = false;
			
			if ((Certificate.getChain() == null) || (Certificate.getChain().getCertificate(0) == Certificate))
			{
				// For proper CRL and OCSP validation please read instructions in 
				// description of ElX509CertificateValidator class in the help file
				TElX509CertificateValidatorResult result = new TElX509CertificateValidatorResult();
				CertificateValidator.validateForSSL(Certificate, Client.getRemoteHost(), Client.getRemoteIP(), TSBHostRole.hrServer, null, false, new Date(), result);
				accept.value = (result.Validity == TSBCertificateValidity.cvOk) || (result.Validity == TSBCertificateValidity.cvSelfSigned);
			}
			else
				accept.value = true; 
		}
	};
	
	TSBFTPSTextDataEvent.Callback onControlSend = new TSBFTPSTextDataEvent.Callback() {
		
		public void tsbftpsTextDataEventCallback(TObject sender, byte[] textLine) {
			editOutput.setText(editOutput.getText() + ">>>" + new String(textLine) + "\n");
		}
	};
	
	TSBCertificateNeededExEvent.Callback onCertificateNeededEx = new TSBCertificateNeededExEvent.Callback() {
		
		public TElX509Certificate tsbCertificateNeededExEventCallback(TObject sender) {
			TElX509Certificate Certificate;
			
			if (FUseCert && (FNeededIndex == 0))
			{
				Certificate = Cert;
				FNeededIndex++;
			}
			else
			{
				Certificate = null;
			}

			return Certificate;
		}
	};
	
	TSBFTPSTextDataEvent.Callback onControlReceive = new TSBFTPSTextDataEvent.Callback() {
		
		public void tsbftpsTextDataEventCallback(TObject sender, byte[] textLine) {
			editOutput.setText(editOutput.getText() + "<<<" + new String(textLine) + "\n");
		}
	};
	
	TSBErrorEvent.Callback onSSLError = new TSBErrorEvent.Callback() {
		
		public void tsbErrorEventCallback(TObject sender, int errorCode, boolean fatal,
				boolean remote) {
			String S;
			if (fatal)
				S = "Fatal ";
			else
				S = "";
			if (remote) 
			    S = S + "Remote ";
			else
				S = S + "Local ";

			S = S + "Error " + errorCode;
			Log(S, true);
			Log("If you are getting error 75778, this can mean that the remote server doens''t support specified SSL/TLS version", false);			
		}
	};
	
	TSBFTPSTextDataEvent.Callback onTextDataLine = new TSBFTPSTextDataEvent.Callback() {
		
		public void tsbftpsTextDataEventCallback(TObject sender, byte[] textLine) {
			editOutput.setText(editOutput.getText() + new String(textLine) + "\n");
		}
	};

	protected void onDisconnectClick() {
		Disconnect();
	}

	protected void onConnectClick() {
		Connect();
	}
	
	private void Connect()
	{
		FileInputStream F;
		int R;
		String S;

		if (Client.getActive())
		{
			showMessage("Already connected, please disconnect first");
			return;
		}

		ConnDialog propsForm = new ConnDialog();
		propsForm.setModal(true);
		propsForm.setVisible(true);
		if (propsForm.isOK())
		{
			editOutput.setText("");
			clearLogTable();

			Client.setAddress(propsForm.getHost());
			Client.setPort(propsForm.getPort());
			Client.setUsername(propsForm.getUsername());
			Client.setPassword(propsForm.getPassword());
			Client.setVersions((short) 0);
			
			if (propsForm.getSSL2()) 
				Client.setVersions((short) (Client.getVersions() + SBSSLConstants.sbSSL2));
			if (propsForm.getSSL3()) 
				Client.setVersions((short) (Client.getVersions() + SBSSLConstants.sbSSL3));
			if (propsForm.getTLS1()) 
				Client.setVersions((short) (Client.getVersions() + SBSSLConstants.sbTLS1));
			if (propsForm.getTLS11())
				Client.setVersions((short) (Client.getVersions() + SBSSLConstants.sbTLS11));
			if (propsForm.getTLS12())
				Client.setVersions((short) (Client.getVersions() + SBSSLConstants.sbTLS12));
			
			FUseCert = false;
			if ((propsForm.getCertText().length() > 0) && (new File(propsForm.getCertText()).exists()))
			{
				try
				{
					F = new FileInputStream(propsForm.getCertText());
					long len = new File(propsForm.getCertText()).length();
					R = Cert.loadFromStreamPFX(F, propsForm.getCertPassword(), (int) len);
					if (R == 0)
					{
						FUseCert = true;
						Log("Certificate loaded OK", false);
					}
					else
						Log("Failed to load certificate, PFX error " + R, true);
				}
				catch (Exception E)
				{
					Log(E.getMessage(), true);
				}
			}

			Log("Connecting to " + Client.getAddress() + ":" + Client.getPort(), false);
			Client.setUseSSL(propsForm.getUseSSL());
			Client.setEncryptDataChannel(!propsForm.getClear());

			Client.setAuthCmd(propsForm.getAuthCmd());
			Client.setPassiveMode(propsForm.getPassive());
			
			if (propsForm.getImplicit())
                Client.setSSLMode(TSBSSLMode.smImplicit);
			else
                Client.setSSLMode(TSBSSLMode.smExplicit);

			FNeededIndex = 0;
			ElMemoryCertStorage.clear();

			try
			{
				Client.open();
				Log("Connected", false);

				Client.login();
				Log("Logged in", false);

				if (Client.getUseSSL())
				{
					switch (Client.getVersion()) 
					{
						case SBSSLConstants.sbSSL2 : 
							S = "SSL2";
							break;
						case SBSSLConstants.sbSSL3 : 
							S = "SSL3";
							break;
						case SBSSLConstants.sbTLS1 : 
							S = "TLS1";
							break;
						case SBSSLConstants.sbTLS11 : 
							S = "TLS1.1";
							break;
						default:
							S = "Unknown";
							break;
					}
	
					Log("SSL version is " + S, false);
				}

			}
			catch (Exception E)
			{
				Log(E.getMessage(), true);
			}
		}
	}

	private void Log(String msg, boolean isError) {
		LogTableModel model = (LogTableModel)tableLog.getModel();
		model.addRow(new Date(), msg, isError ? "Eror" : "Info");
		scrollToEndTable(tableLog);
	}

	private void scrollToEndTable(JTable tbl) {
		tbl.scrollRectToVisible(tbl.getCellRect(tbl.getRowCount() - 1, tbl.getColumnCount(), true));		
	}

	private void clearLogTable() {
		((LogTableModel)tableLog.getModel()).clear();
		
	}

	private void showMessage(String msg) {
		JOptionPane.showMessageDialog(null, msg, getTitle(), JOptionPane.INFORMATION_MESSAGE);
	}

	private void Disconnect()
	{
		if (Client.getActive())
		{
			Log("Disconnecting", false);
			try
			{
				Client.close(true);
				Log("Disconnected", false);
			}
			catch (Exception E)
			{
				Log(E.getMessage(), true);
			}
		}
	}	
}
