import SecureBlackbox.Base.SBMD;
import SecureBlackbox.Base.SBRandom;
import SecureBlackbox.Base.SBUtils;

public class UserInfo
{
	private String m_Name = "";
	private String m_PasswordSalt = "";
	private String m_PasswordHash = "";
	private String m_HomeDirectory = "";
	private int m_SpeedLimit = 0;

	public String getName() {
		return m_Name;
	}
	
	public void setName(String value){
		m_Name = value;
	}
	
	public String getPasswordSalt() {
		return m_PasswordSalt;
	}

	public void setPasswordSalt(String value) {
		m_PasswordSalt = value;
	}
	
	public String getPasswordHash()	{
		return m_PasswordHash;
	}

	public void setPasswordHash(String value) {
		m_PasswordHash = value;
	}
	
	public String getHomeDirectory() {
		return m_HomeDirectory;
	}

	public void setHomeDirectory(String value) {
		m_HomeDirectory = value;		
	}
	
	
	public int getSpeedLimit() {
		return m_SpeedLimit;
	}

	public void setSpeedLimit(int value) {
		m_SpeedLimit = value;
	}
	
	public boolean getAnonymous() {
		return m_Name.toLowerCase().compareTo("anonymous") == 0;
	}

	public UserInfo()
	{

	}

	public void setPassword(String password)
	{
		byte[] Salt = new byte[4];
		SBRandom.sbRndGenerate(Salt, 4);
		String PasswordSalt = toHex(Salt);
		setPasswordSalt(PasswordSalt);
		setPasswordHash(calcPasswordHash(PasswordSalt, password));
	}
	
	public static String toHex(byte[] bytes) {
	    java.math.BigInteger bi = new java.math.BigInteger(1, bytes);
	    return String.format("%0" + (bytes.length << 1) + "X", bi);
	}

	private String calcPasswordHash(String Salt, String Password)
	{
		String sHash = Salt + Password;
		byte[] Hash = new byte[sHash.length()];
		for (int i = 0; i < sHash.length(); i++)
			Hash[i] = (byte)sHash.getBytes()[i];
		return SBUtils.digestToStr128(SBMD.hashMD5(Hash), true);
	}
	
	public boolean PasswordValid(String Password)
	{
		return getPasswordHash().compareTo(calcPasswordHash(getPasswordSalt(), Password)) == 0;
	}
}