

import java.awt.EventQueue;

import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import SecureBlackbox.Base.*;
import SecureBlackbox.HTTPClient.*;
import SecureBlackbox.HTTPCommon.*;
import SecureBlackbox.SSLClient.*;
import SecureBlackbox.SSLCommon.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Date;

import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

import org.freepascal.rtl.TObject;


public class Main extends JDialog {

	private static final long serialVersionUID = 1L;
	private JTextField edHost;
	private JTextField edPath;
	private JTextField edOutput;
	private JComboBox<String> cmbProtocol;
	private TElHTTPSClient HTTPSClient;
	private TElX509CertificateValidator CertificateValidator;
	private JSpinner edPort;
	private JTextArea mmLog;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("HTTP Get");
		setBounds(100, 100, 416, 300);
		getContentPane().setLayout(null);
		
		JLabel lblProtocol = new JLabel("Protocol");
		lblProtocol.setBounds(10, 11, 61, 14);
		getContentPane().add(lblProtocol);
		
		JLabel lblHost = new JLabel("Host");
		lblHost.setBounds(10, 36, 61, 14);
		getContentPane().add(lblHost);
		
		JLabel lblPath = new JLabel("Path");
		lblPath.setBounds(10, 61, 61, 14);
		getContentPane().add(lblPath);
		
		JLabel lblSaveTo = new JLabel("Save to");
		lblSaveTo.setBounds(10, 86, 61, 14);
		getContentPane().add(lblSaveTo);
		
		cmbProtocol = new JComboBox<String>();
		cmbProtocol.setModel(new DefaultComboBoxModel<String>(new String[] {"HTTP", "HTTPS"}));
		cmbProtocol.setBounds(81, 7, 77, 22);
		getContentPane().add(cmbProtocol);
		
		edHost = new JTextField();
		edHost.setText("www.eldos.com");
		edHost.setBounds(81, 33, 159, 20);
		getContentPane().add(edHost);
		edHost.setColumns(10);
		
		edPath = new JTextField();
		edPath.setText("/");
		edPath.setBounds(81, 58, 219, 20);
		getContentPane().add(edPath);
		edPath.setColumns(10);
		
		edOutput = new JTextField();
		edOutput.setBounds(81, 83, 219, 20);
		getContentPane().add(edOutput);
		edOutput.setColumns(10);
		
		JButton btnBrowse = new JButton("Browse");
		btnBrowse.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				edOutput.setText(getSaveFileName());
			}
		});
		btnBrowse.setBounds(310, 82, 91, 23);
		getContentPane().add(btnBrowse);
		
		JButton btnRetrieve = new JButton("Retrieve");
		btnRetrieve.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				retrieveClick();
			}
		});
		btnRetrieve.setBounds(310, 57, 91, 23);
		getContentPane().add(btnRetrieve);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 119, 387, 143);
		getContentPane().add(scrollPane);
		
		mmLog = new JTextArea();
		scrollPane.setViewportView(mmLog);
		
		JLabel lblPort = new JLabel("Port");
		lblPort.setBounds(263, 36, 37, 14);
		getContentPane().add(lblPort);
		
		edPort = new JSpinner();
		edPort.setModel(new SpinnerNumberModel(new Integer(80), null, null, new Integer(1)));
		edPort.setBounds(310, 33, 51, 20);
		getContentPane().add(edPort);

		init();
	}

	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");

		// to involve windows stores into certificates validation process
		JNI.initialize();

		// The following lines are required for HTTP retrieval of CRLs and OCSP in TElX509CertificateValidator to work
		SBHTTPCRL.registerHTTPCRLRetrieverFactory();
		SBHTTPOCSPClient.registerHTTPOCSPClientFactory();
		
		HTTPSClient = new TElHTTPSClient();
		HTTPSClient.setHTTPVersion(TSBHTTPVersion.hvHTTP11);
    
		CertificateValidator = new TElX509CertificateValidator();
		CertificateValidator.setMandatoryCRLCheck(false);

		initEvents();
	}

	private void initEvents() {
		HTTPSClient.setOnReceivingHeaders(new TSBHTTPHeadersEvent(onReceivingHeaders));
		HTTPSClient.setOnDocumentBegin(new TNotifyEvent(onDocumentBegin));
		HTTPSClient.setOnCloseConnection(new TSBCloseConnectionEvent(onCloseConnection));
		HTTPSClient.setOnRedirection(new TSBHTTPRedirectionEvent(onRedirection));
		HTTPSClient.setOnDocumentEnd(new TNotifyEvent(onDocumentEnd));
		HTTPSClient.setOnData(new TSBDataEvent(onData));
		HTTPSClient.setOnPreparedHeaders(new TSBHTTPHeadersEvent(onPreparedHeaders));
		HTTPSClient.setOnCertificateValidate(new TSBCertificateValidateEvent(onCertificateValidate));		
	}

	TSBHTTPHeadersEvent.Callback onReceivingHeaders = new TSBHTTPHeadersEvent.Callback() {
		
		public void tsbhttpHeadersEventCallback(TObject sender, TElStringList headers) {
			mmLog.append("\nReceived headers: \n" + headers.getText() + "\n");				
		}
	};
	
	TNotifyEvent.Callback onDocumentBegin = new TNotifyEvent.Callback() {
		
		public void tNotifyEventCallback(TObject sender) {
			mmLog.append("\n-- Document started --\n");		
		}
	};
	
	TSBCloseConnectionEvent.Callback onCloseConnection = new TSBCloseConnectionEvent.Callback() {
		
		public void tsbCloseConnectionEventCallback(TObject sender,
				TSBCloseReason reason) {
			mmLog.append("\n-- Connection closed --\n");		
		}
	};
	
	TSBHTTPRedirectionEvent.Callback onRedirection = new TSBHTTPRedirectionEvent.Callback() {
		
		public void tsbhttpRedirectionEventCallback(TObject sender, String oldURL, TSBString newURL, TSBBoolean accept) {
			mmLog.append("\nRedirected to " + newURL + "\n");
			newURL.value = newURL.value; // can be changed here
			accept.value = true;
		}
	};
	
	TNotifyEvent.Callback onDocumentEnd = new TNotifyEvent.Callback() {
		
		public void tNotifyEventCallback(TObject arg0) {
			mmLog.append("\n-- Document finished --\n");		
		}
	};
	
	TSBDataEvent.Callback onData = new TSBDataEvent.Callback() {
		
		public void tsbDataEventCallback(TObject sender, byte[] data) {
			mmLog.append(new String(data));		
		}
	};
	
	TSBHTTPHeadersEvent.Callback onPreparedHeaders = new TSBHTTPHeadersEvent.Callback() {
		
		public void tsbhttpHeadersEventCallback(TObject sender, TElStringList headers) {
			mmLog.append("\nSending headers: \n" + headers.getText() + "\n");		
		}
	};
	
	TSBCertificateValidateEvent.Callback onCertificateValidate = new TSBCertificateValidateEvent.Callback() {
		
		public void tsbCertificateValidateEventCallback(TObject sender,
				TElX509Certificate X509Certificate, TSBBoolean accept) {
			
			 accept.value = false;
			if ((X509Certificate.getChain() == null) || (X509Certificate.getChain().getCertificate(0) == X509Certificate))
			{
				// For proper CRL and OCSP validation please read instructions in 
				// description of ElX509CertificateValidator class in the help file
				TElX509CertificateValidatorResult result = new TElX509CertificateValidatorResult();
				CertificateValidator.validateForSSL(X509Certificate, HTTPSClient.getRemoteHost(), HTTPSClient.getRemoteIP(), TSBHostRole.hrServer, null, false, new Date(), result );
				accept.value = (result.Validity == TSBCertificateValidity.cvOk) || (result.Validity == TSBCertificateValidity.cvSelfSigned);
			}
			else	
				accept.value = true; 
			
		}
	};

	private void showErrorMessage(String msg) {
		JOptionPane.showMessageDialog(null, msg, getTitle(), JOptionPane.ERROR_MESSAGE);
	}
	
	String getSaveFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

		return "";
	} 

	protected void retrieveClick() {
		String URL = cmbProtocol.getSelectedItem().toString().toLowerCase() + "://" + edHost.getText() + ":" + edPort.getValue().toString() + edPath.getText();
		
		TElFileStream Stream = null;
		if (edOutput.getText().length() > 0)
		{
			try
			{
				Stream = new TElFileStream(edOutput.getText(), "rw", true);
			}
			catch(Exception ex)	
			{
				mmLog.append("\nWarning: Failed to create output stream.\n");
			}
		}
		HTTPSClient.setOutputStream(Stream);
		try
		{
			HTTPSClient.get(URL);
		}
		catch (Exception E)
		{
			showErrorMessage("Exception happened during HTTP download: " + E.getMessage());
		}
		HTTPSClient.close(true);
		if (Stream != null)
			Stream.Free();
		HTTPSClient.setOutputStream(null);
	}
}
