import SecureBlackbox.MIME.*;

public class ElMessageDemo extends TElMessage
{
  String fDataFile;
  TAnsiStringMIMEStream fDataStream = null;
  int fResult = SBMIME.EL_OK;
  ElMimeParserTask fParserThread;
  boolean fUseBackgroundParser = false;

  private static String xMailer = "EldoS ElMime Demos, ver: "+MimeViewer_PlugControl.getVersion() +
    " ( " +  SBMIME.cXMailerDefaultFieldValue + " )";

  public ElMessageDemo()
  {
	  super(xMailer);
	  fDataStream = new TAnsiStringMIMEStream();
  }

  void dispose()
  {
    if (fParserThread != null) {
      if ( fUseBackgroundParser ) {
        fParserThread.Terminate();
        fParserThread.WaitFor();
      }
      fParserThread.Dispose();
    }
    fDataFile = null;
    if ( fDataStream != null ) {
    	fDataStream.Free();
      fDataStream = null;
    }
  }

  public String getDataFile()
  {
      return fDataFile;
  }
  
  public void setDataFile(String value) {
      fDataFile = value;
  }

  public int getResult()
  {
      return fResult;
  }

  public boolean getUseBackgroundParser()
  {
      return fUseBackgroundParser;
  }

  public TAnsiStringMIMEStream getDataStream()
  {
      return fDataStream;
  }

  public void InitMailAdressFields(String[] aFields){
    for (int i = 0; i < aFields.length; i++)
    {
	    if (getHeaderField(aFields[i]) != null )
	      getMailAddressList( aFields[i] );
   }
  }
}
