import SecureBlackbox.Base.*;
import SecureBlackbox.MIME.*;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import java.awt.Dimension;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import java.awt.Color;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTable;


public class MimeViewer_Binary extends MimeViewer_PlugControl {

	private static final long serialVersionUID = 1L;
	
	//private boolean bBinaryDataLoaded = false;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	private JTable binaryTable;
	private JTextArea textBox;
	private JRadioButton radioButton_binary;
	private JRadioButton radioButton_text;
	
	public MimeViewer_Binary() {
		setLayout(new BorderLayout(0, 0));
		
		JPanel panel = new JPanel();
		panel.setPreferredSize(new Dimension(10, 50));
		add(panel, BorderLayout.NORTH);
		panel.setLayout(null);
		
		JButton btnSaveToFile = new JButton("Save to File");
		btnSaveToFile.setBounds(10, 11, 91, 23);
		panel.add(btnSaveToFile);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBackground(Color.LIGHT_GRAY);
		panel_1.setBounds(122, 8, 108, 28);
		panel.add(panel_1);
		panel_1.setLayout(null);
		
		JLabel lblViewMode = new JLabel("View Mode:");
		lblViewMode.setBounds(10, 8, 88, 14);
		panel_1.add(lblViewMode);
		
		radioButton_binary = new JRadioButton("Binary");
		radioButton_binary.setSelected(true);
		buttonGroup.add(radioButton_binary);
		radioButton_binary.setBounds(229, 11, 74, 23);
		panel.add(radioButton_binary);
		
		radioButton_text = new JRadioButton("Text");
		buttonGroup.add(radioButton_text);
		radioButton_text.setBounds(309, 11, 109, 23);
		panel.add(radioButton_text);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setPreferredSize(new Dimension(260, 4));
		add(scrollPane, BorderLayout.WEST);
		
		textBox = new JTextArea();
		scrollPane.setViewportView(textBox);
		
		binaryTable = new JTable();
		add(binaryTable, BorderLayout.CENTER);
		fCaption = "Binary Data Part";
	}
	
	public boolean IsSupportedMessagePart(TElMessagePart messagePart, TagInfo tagInfo, TreeNodeInfo treeNodeItem)
	{
		if ( (tagInfo != TagInfo.tiBody) || (treeNodeItem == null)
			|| (messagePart == null) || (messagePart.isMultipart()) )
			return false;
		else
			return true;
	}

	protected void Init(TElMessagePart messagePart, TagInfo tagInfo, TreeNodeInfo treeNodeItem, boolean bShow)
	{
		fTagInfo = tagInfo;
		fElMessagePart = messagePart;
		fNode = treeNodeItem;
	
		if ( (fElMessagePart == null) || (! bShow) )
			return;
	
		bPlainTextLoaded = false;
		//bBinaryDataLoaded = false;
	
		radioButton_binary_CheckedChanged();
		radioButton_text_CheckedChanged();
	
	}
	
	private boolean bPlainTextLoaded = false;
	private void LoadPlainText()
	{
		if ( bPlainTextLoaded )
			return;
		textBox.setText("");
		TSBString ws = new TSBString();
		if ( fElMessagePart.isText() )
		{
			fElMessagePart.getText(ws);
			textBox.setText(ws.value);
		}
		else
		{

			TByteArrayConst buffer = new TByteArrayConst();
			TSBInteger iBuffSize = new TSBInteger();
			fElMessagePart.getData(buffer, iBuffSize);
			buffer = new TByteArrayConst();
			fElMessagePart.getData(buffer, iBuffSize);
			textBox.setText(new String(buffer.Data));
		}
		bPlainTextLoaded = true;
	}
	
	private void LoadBinaryData()
	{
		TSBInteger iBuffSize = new TSBInteger();
		byte[] iRow = new byte[16];
		TByteArrayConst buffer = new TByteArrayConst();
		fElMessagePart.getData(buffer, iBuffSize);
		buffer = new TByteArrayConst();
		fElMessagePart.getData(buffer, iBuffSize);
	
		clearBinaryTable();
	
		try
		{
			iBuffSize.value = buffer.length();
			int iOffs = 0;
			String S = String.format("{%x}", iBuffSize);
			int iOffsCnt = S.length();
			S = "";
			StringBuilder sText;
			int idx = 0;
			int chb;
			char ch;

			BinTableModel model = (BinTableModel)binaryTable.getModel();

			for ( int i=0; i < iBuffSize.value; i++ ) 
			{
				idx = i % 16;
	
				iRow[ idx ] = buffer.Data[i];
	
				if (idx == 15)
				{
					sText = new StringBuilder(32*2+10);
		
					String offset = "0x" + String.format("{%x" + iOffsCnt + "}", iOffs);
					iOffs = i+1;
	
					for (idx = 0; idx < 8; idx ++)
					{
						S =  String.format("{0:X2}", iRow[idx * 2]) +
							String.format("{0:X2}", iRow[idx * 2+1]);
						//row[(idx * 2)] =  S;
						chb = iRow[idx * 2];
						if ((chb == 13)  || (chb == 10) || (chb == 0))
							ch = ' ';
						else
							ch = (char) chb;
						sText.append( ch );
	
						chb = (iRow[idx * 2+1]);
						if ((chb == 13)  || (chb == 10) || (chb == 0))
							ch = ' ';
						else
							ch = (char) chb;
						sText.append( ch );
					}
	    
					String text = sText.toString();
	
					model.addItem(offset, text);
				}
			}
	
			//sText = new System.Text.StringBuilder(32*2+10);
			idx = iBuffSize.value % 16;
			if ( idx > 0 ) 
			{
				for ( int i=idx; i<16; i++ )
				{
					iRow[i] = 0;
				}
	
				sText = new StringBuilder(32*2+10);
	
				String msg = "{%x" + iOffsCnt + "}";
				String offset = "0x" + String.format(msg, iOffs);
	
				for (idx = 0; idx < 8; idx ++)
				{
					S =  String.format("{%x}", iRow[idx * 2+0]) +
						String.format("{%x}", iRow[idx * 2+1]);
					//row[idx * 2] =  S;
					chb = iRow[idx * 2];
					if ((chb == 13)  || (chb == 10) || (chb == 0))
						ch = ' ';
					else
						ch = (char) chb;
					sText.append( ch );
	
					chb = (iRow[idx * 2+1]);
						if ((chb == 13)  || (chb == 10) || (chb == 0))
							ch = ' ';
						else
							ch = (char) chb;
					sText.append( ch );
				}
	
				String text = sText.toString();
	
				model.addItem(offset, text);
			}
		}
		finally
		{
		}
	
		//bBinaryDataLoaded = true;
	}
	
	private void clearBinaryTable() {
		BinTableModel model = (BinTableModel)binaryTable.getModel();
		model.clear();
	}

	private void radioButton_binary_CheckedChanged()
	{
		binaryTable.setVisible(radioButton_binary.isSelected());
		if (radioButton_binary.isSelected())
			LoadBinaryData();
	}
	
	private void radioButton_text_CheckedChanged()
	{
		textBox.setVisible(radioButton_text.isSelected());
		if ( radioButton_text.isSelected() )
			LoadPlainText();
	}
}
