import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class PanelSelectFilesDescriptor extends WizardPanelDescriptor implements ActionListener {

    public static final String IDENTIFIER = "SELECT_PANEL";
    static PanelSelectFiles panel;
    
    public PanelSelectFilesDescriptor() {
    	panel = new PanelSelectFiles();
        panel.addFieldsListener(this);

        setPanelDescriptorIdentifier(IDENTIFIER);
        setPanelComponent(panel);
    }
    
    public Object getNextPanelDescriptor() {  
    	return PanelSelectSourceDescriptor.IDENTIFIER;
    }
    
    public Object getBackPanelDescriptor() {
        return PanelOperationSelectDescriptor.IDENTIFIER;
    }
    
    public void aboutToDisplayPanel(){
    	setNextButtonAccordFields();
    }
   
	private void setNextButtonAccordFields() {
		getWizard().setNextFinishButtonEnabled(panel.isFieldsValidated());
	}

	public void actionPerformed(ActionEvent e) {
    	setNextButtonAccordFields();
    }

	public static String getSecKeyringPath() {
		return panel.getSecKeyringPath();
	}

	public static String getPubKeyringPath() {
		return panel.getPubKeyringPath();
	}
}
