import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.JPasswordField;
import javax.swing.JComboBox;
import javax.swing.JCheckBox;
import javax.swing.ButtonGroup;

import SecureBlackbox.Base.TElWinCertStorage;
import SecureBlackbox.Base.TElX509Certificate;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class AddSigDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbCertFile;
	private JPasswordField paswCert;
	private JTextField tbURL;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	private boolean isOk;
	private JRadioButton rbUseFileCert;
	private JButton btnBrowse;
	private JComboBox<String> cbSystemCerts;
	private JCheckBox chckbxVisibleSignature;
	private JCheckBox chckbxCreateEnhancedpades;
	private JCheckBox chckbxRequestATimestamp;
	private JCheckBox chckbxIncludeLocalRevocation;
	private JCheckBox chckbxAutomaticallyCollectRevocation;
	private JCheckBox chckbxIngoreChainValidation;

    private TElX509Certificate m_Cert = null;
    private TElWinCertStorage m_CertStorage = null;
    
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			AddSigDialog dialog = new AddSigDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public AddSigDialog() {
		setTitle("Add signature");
		setBounds(100, 100, 423, 426);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		rbUseFileCert = new JRadioButton("Use certificate from file");
		buttonGroup.add(rbUseFileCert);
		rbUseFileCert.setSelected(true);
		rbUseFileCert.setBounds(6, 7, 268, 23);
		contentPanel.add(rbUseFileCert);
		
		tbCertFile = new JTextField();
		tbCertFile.setBounds(16, 39, 284, 20);
		contentPanel.add(tbCertFile);
		tbCertFile.setColumns(10);
		
		btnBrowse = new JButton("Browse");
		btnBrowse.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tbCertFile.setText(getCertPath());
			}
		});
		btnBrowse.setBounds(310, 38, 91, 23);
		contentPanel.add(btnBrowse);
		
		JLabel lblCertificatePassword = new JLabel("Certificate password");
		lblCertificatePassword.setBounds(16, 70, 119, 14);
		contentPanel.add(lblCertificatePassword);
		
		paswCert = new JPasswordField();
		paswCert.setBounds(16, 95, 150, 20);
		contentPanel.add(paswCert);
		
		JRadioButton rdbtnUseCertificateFrom_1 = new JRadioButton("Use certificate from system certificate storage");
		buttonGroup.add(rdbtnUseCertificateFrom_1);
		rdbtnUseCertificateFrom_1.setBounds(6, 122, 290, 23);
		contentPanel.add(rdbtnUseCertificateFrom_1);
		
		cbSystemCerts = new JComboBox<String>();
		cbSystemCerts.setBounds(16, 152, 385, 22);
		contentPanel.add(cbSystemCerts);
		
		chckbxVisibleSignature = new JCheckBox("Visible signature");
		chckbxVisibleSignature.setBounds(6, 181, 129, 23);
		contentPanel.add(chckbxVisibleSignature);
		
		chckbxCreateEnhancedpades = new JCheckBox("Create enhanced (PAdES) signature");
		chckbxCreateEnhancedpades.setBounds(137, 181, 264, 23);
		contentPanel.add(chckbxCreateEnhancedpades);
		
		chckbxRequestATimestamp = new JCheckBox("Request a timestamp from TSA server");
		chckbxRequestATimestamp.setBounds(6, 207, 385, 23);
		contentPanel.add(chckbxRequestATimestamp);
		
		tbURL = new JTextField();
		tbURL.setText("http://");
		tbURL.setBounds(16, 237, 385, 20);
		contentPanel.add(tbURL);
		tbURL.setColumns(10);
		
		chckbxIncludeLocalRevocation = new JCheckBox("Include local revocation information to the signature");
		chckbxIncludeLocalRevocation.setBounds(6, 271, 309, 23);
		contentPanel.add(chckbxIncludeLocalRevocation);
		
		chckbxAutomaticallyCollectRevocation = new JCheckBox("Automatically collect revocation information (CRLs, OCSP statuses)");
		chckbxAutomaticallyCollectRevocation.setBounds(6, 297, 395, 23);
		contentPanel.add(chckbxAutomaticallyCollectRevocation);
		
		chckbxIngoreChainValidation = new JCheckBox("Ignore chain validation errors");
		chckbxIngoreChainValidation.setBounds(6, 323, 395, 23);
		contentPanel.add(chckbxIngoreChainValidation);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("Add");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
			            if (rbUseFileCert.isSelected())
			            {
			                int r = m_Cert.loadFromFileAuto(tbCertFile.getText(), new String(paswCert.getPassword()));
			                if (r != 0)
			                {
			                    showMessage("Failed to load certificate, error " + r);
			                    return;
			                }
			            }
			            else
			            {
			                if (cbSystemCerts.getSelectedIndex() >= 0)
			                {
			                    m_CertStorage.getCertificate(cbSystemCerts.getSelectedIndex()).clone(m_Cert, true);
			                }
			                else
			                {
			                    showMessage("Please select a certificate");
			                    return;
			                }
			            }						
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		init();
	}

	protected String getCertPath() {
		JFileChooser fc = new JFileChooser();
		fc.setDialogTitle("Select certificate file");

		FileNameExtensionFilter filter = new FileNameExtensionFilter("X.509 certificate", "cer", "crt", "csr", "pem", "pfx", "*");
		fc.setFileFilter(filter);

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	void showMessage(String msg){
		JOptionPane.showMessageDialog(null, msg, getTitle(), JOptionPane.INFORMATION_MESSAGE);
	}

	private void init() {
		m_Cert = new TElX509Certificate();
        m_CertStorage = new TElWinCertStorage();
        try
        {
            m_CertStorage.getSystemStores().add("MY");
        }
        finally
        {
        }
        for (int i = 0; i < m_CertStorage.getCount(); i++)
        {
            cbSystemCerts.addItem(m_CertStorage.getCertificate(i).getSubjectRDN().saveToDNString());
        } 
	}

	public boolean isOK() {
		return isOk;
	}

	public TElX509Certificate getCert() {
		return m_Cert;
	}

	public boolean getVisibleChecked() {
		return chckbxVisibleSignature.isSelected();
	}

	public boolean getEnhancedSig() {
		return chckbxCreateEnhancedpades.isSelected();
	}

	public boolean getRequestTimestamp() {
		return chckbxRequestATimestamp.isSelected();
	}

	public String getTSAURL() {
		return tbURL.getText();
	}

	public boolean getIncludeLocalRevInfo() {
		return chckbxIncludeLocalRevocation.isSelected();
	}

	public boolean getAutoCollectRevInfoChecked() {
		return chckbxAutomaticallyCollectRevocation.isSelected();
	}

	public boolean getIgnoreChainValidationErrorsChecked() {
		return chckbxIngoreChainValidation.isSelected();
	}
}
