import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.util.ArrayList;
import java.util.Date;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileNameExtensionFilter;

import SecureBlackbox.Base.SBCustomCertStorage;
import SecureBlackbox.Base.TElCertificateLookup;
import SecureBlackbox.Base.TElFileStream;
import SecureBlackbox.Base.TElMemoryCRLStorage;
import SecureBlackbox.Base.TElOCSPResponse;
import SecureBlackbox.Base.TElPKCS7Issuer;
import SecureBlackbox.Base.TElX509Certificate;
import SecureBlackbox.Base.TElX509CertificateValidator;
import SecureBlackbox.Base.TElX509CertificateValidatorResult;
import SecureBlackbox.Base.TSBCertificateValidity;
import SecureBlackbox.Base.TSBPKCS7IssuerType;
import SecureBlackbox.PDF.TElPDFDocument;
import SecureBlackbox.PDF.TElPDFPublicKeySecurityHandler;
import SecureBlackbox.PDF.TElPDFSignature;

import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class SigPropsDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JComboBox<String> cbSignatures;
	private ArrayList<TElPDFSignature> objects;
	private JTextField tbAuthorName;
	private JTextField tbReason;
	private JPanel pSignatureInfo;
	private JLabel lTimestamp;

	private TElX509CertificateValidator CertificateValidator;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			SigPropsDialog dialog = new SigPropsDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public SigPropsDialog() {
		setTitle("Signature properties");
		setBounds(100, 100, 377, 345);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JLabel lblTheDocumentContains = new JLabel("The document contains the following digital signatures");
			lblTheDocumentContains.setBounds(10, 11, 394, 14);
			contentPanel.add(lblTheDocumentContains);
		}
		
		cbSignatures = new JComboBox<String>();
		cbSignatures.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (cbSignatures.getSelectedIndex() != -1) 
				{
					TElPDFSignature sig = (TElPDFSignature)objects.get(cbSignatures.getSelectedIndex());
					if (sig.getAuthorName().length() > 0) 
						tbAuthorName.setText(sig.getAuthorName());
					else 
						tbAuthorName.setText("<not specified>");

					if (sig.getReason().length() > 0) 
						tbReason.setText(sig.getReason());
					else 
						tbReason.setText("<not specified>");
					lTimestamp.setText("Timestamp: " + sig.getSigningTime() + " (local)");
					pSignatureInfo.setVisible(true);
				} 
				else 
					pSignatureInfo.setVisible(false);

			}
		});
		cbSignatures.setBounds(10, 32, 348, 22);
		contentPanel.add(cbSignatures);
		
		pSignatureInfo = new JPanel();
		pSignatureInfo.setBounds(10, 65, 349, 209);
		contentPanel.add(pSignatureInfo);
		pSignatureInfo.setLayout(null);
		
		JLabel label = new JLabel("Author's name");
		label.setBounds(0, 0, 217, 14);
		pSignatureInfo.add(label);
		
		tbAuthorName = new JTextField();
		tbAuthorName.setEditable(false);
		tbAuthorName.setColumns(10);
		tbAuthorName.setBounds(0, 18, 348, 20);
		pSignatureInfo.add(tbAuthorName);
		
		JLabel label_1 = new JLabel("Reason for signing");
		label_1.setBounds(0, 49, 204, 14);
		pSignatureInfo.add(label_1);
		
		tbReason = new JTextField();
		tbReason.setEditable(false);
		tbReason.setColumns(10);
		tbReason.setBounds(0, 69, 348, 20);
		pSignatureInfo.add(tbReason);
		
		lTimestamp = new JLabel("Timestamp");
		lTimestamp.setBounds(0, 100, 348, 14);
		pSignatureInfo.add(lTimestamp);
		
		JButton btnValidate = new JButton("Validate");
		btnValidate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				validateClick();
			}
		});
		btnValidate.setBounds(257, 125, 91, 23);
		pSignatureInfo.add(btnValidate);
		
		JButton btnExtract = new JButton("Extract signed version");
		btnExtract.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				exClick();
			}
		});
		btnExtract.setBounds(175, 159, 173, 23);
		pSignatureInfo.add(btnExtract);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		
		init();
	}

	protected void exClick() {
		if (cbSignatures.getSelectedIndex() == -1) return;
		String fileName = getSaveFileName();
		if (fileName.length() > 0)
		{
			TElFileStream F = new TElFileStream(fileName, "rw", true);
			try
			{
				TElPDFSignature sig = (TElPDFSignature)(objects.get(cbSignatures.getSelectedIndex()));
				sig.getSignedVersion(F);
			}
			finally { 
				F.Free(); 
			}
		}                
	}

	private String getSaveFileName() {
		JFileChooser fc = new JFileChooser();
		
		FileNameExtensionFilter filter = new FileNameExtensionFilter("PDF files", "pdf");
	    fc.setFileFilter(filter);	
	    
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	protected void validateClick() {
		TElPDFPublicKeySecurityHandler SecHandler;
		int j, k, idx;
		TElPKCS7Issuer CertID;
		TElCertificateLookup Lookup = new TElCertificateLookup();
		TSBCertificateValidity Validity = TSBCertificateValidity.cvInvalid;
		TElMemoryCRLStorage TempCRLStorage;
		TElOCSPResponse TempResponse;
		Date ValidityTime = new Date();
		boolean TSSet = false;
		TElX509Certificate Cert;

		if (cbSignatures.getSelectedIndex() == -1) return;

		TElPDFSignature sig = (TElPDFSignature)(objects.get(cbSignatures.getSelectedIndex()));
		if (sig.validate())
		{
			if (!sig.isDocumentSigned())
			{
				showErrorMessage("The selected signature does not cover the entire document", "Failure");	
			}

			if (sig.getHandler() instanceof TElPDFPublicKeySecurityHandler)
			{

				SecHandler = (TElPDFPublicKeySecurityHandler)sig.getHandler();

				for (j = 0; j < SecHandler.getCertIDCount(); j++)
				{

					CertID = SecHandler.getCertIDs(j);

					Lookup.setCriteria(0);
					Lookup.setOptions(SBCustomCertStorage.loMatchAll);

					if (CertID.getIssuerType() == TSBPKCS7IssuerType.itSubjectKeyIdentifier)
					{
						Lookup.setSubjectKeyIdentifier(CertID.getSubjectKeyIdentifier());
						Lookup.setCriteria(SBCustomCertStorage.lcSubjectKeyIdentifier);
					}
					else
					{
						Lookup.getIssuerRDN().assign(CertID.getIssuer());
						Lookup.setSerialNumber(CertID.getSerialNumber());
						Lookup.setCriteria(SBCustomCertStorage.lcIssuer | SBCustomCertStorage.lcSerialNumber);
					}
					idx = SecHandler.getCertificates().findFirst(Lookup);
					if (idx != -1)
					{
						CertificateValidator.clearTrustedCertificates();
						CertificateValidator.clearBlockedCertificates();
						CertificateValidator.clearKnownCertificates();
						CertificateValidator.clearKnownCRLs();
						CertificateValidator.clearKnownOCSPResponses();

						CertificateValidator.addKnownCertificates(SecHandler.getCertificates());

						TempCRLStorage = new TElMemoryCRLStorage();

						for (k = 0; k < SecHandler.getRevocationInfo().getCRLCount(); k++)
							TempCRLStorage.add(SecHandler.getRevocationInfo().getCRL(k));

						CertificateValidator.addKnownCRLs(TempCRLStorage);

						TempResponse = new TElOCSPResponse();
						for (k = 0; k < SecHandler.getRevocationInfo().getOCSPResponseCount(); k++)
						{
							TempResponse.load(SecHandler.getRevocationInfo().getOCSPResponse(k), 0, SecHandler.getRevocationInfo().getOCSPResponse(k).length);
							CertificateValidator.addKnownOCSPResponses(TempResponse);
						}

						if (SecHandler.getTimestampCount() > 0)
						{
							Cert = SecHandler.getTimestamp(0).getSignerCertificate();
							if (Cert != null)
							{
								// For proper CRL and OCSP validation please read instructions in 
								// description of ElX509CertificateValidator class in the help file
								TElX509CertificateValidatorResult vres = new TElX509CertificateValidatorResult();
								CertificateValidator.validate(Cert, SecHandler.getTimestamp(0).getCertificates(), false, SecHandler.getTimestamp(0).getTime(), vres);
							}
							else
								Validity = TSBCertificateValidity.cvOk;

							if (Validity == TSBCertificateValidity.cvOk)
							{
								ValidityTime = SecHandler.getTimestamp(0).getTime();
								TSSet = true;
							}
							else
								ValidityTime = new Date();
						}
						else
							ValidityTime = new Date();

						TElX509CertificateValidatorResult vvres = new TElX509CertificateValidatorResult();
						CertificateValidator.validate(SecHandler.getCertificates().getCertificate(idx), null, false, ValidityTime, vvres);
						if (Validity != TSBCertificateValidity.cvOk)
							break;
					}
				}
				if (Validity == TSBCertificateValidity.cvOk)
				{
					showMessage("The selected signature is VALID", "Success");
					if (TSSet)
						lTimestamp.setText("Timestamp: " + ValidityTime.toString() + "(TSA)");
				}
				else
				if (Validity == TSBCertificateValidity.cvSelfSigned)
				{
					showMessage("The selected signature is signed by self-signed certificate which was not previously trusted", "Success");
					if (TSSet)
						lTimestamp.setText("Timestamp: " + ValidityTime.toString() + "(TSA)");
				}
				else
					showErrorMessage("The selected signature is signed by certificate that is NOT VALID", "Failure");
			}
		}
		else
			showErrorMessage("The selected signature is NOT VALID", "Failure");	
	}

	private void init() {
		objects = new ArrayList<TElPDFSignature>();
		CertificateValidator = new TElX509CertificateValidator();
	}

	public void Init(TElPDFDocument doc) {
        cbSignatures.removeAll();
		objects.clear();
		tbAuthorName.setText("");
		tbReason.setText("");
		pSignatureInfo.setVisible(false);
		for (int i = 0; i < doc.getSignatureCount(); i++) 
		{
			objects.add(doc.getSignatureEntry(i));
            cbSignatures.addItem(doc.getSignatureEntry(i).getSignatureName());
		}
	}
	
	void showMessage(String caption, String msg) {
		JOptionPane.showMessageDialog(null, msg, caption, JOptionPane.INFORMATION_MESSAGE);
	}	
	
	void showErrorMessage(String msg, String cap){
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.ERROR_MESSAGE);
	}
}
