

import SecureBlackbox.Base.*;
import SecureBlackbox.PKI.*;

import javax.swing.*;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.SimpleTimeZone;


public class Main extends JDialog implements ActionListener {
	private static final long serialVersionUID = -8938687539889635131L;
	private final JPanel contentPanel = new JPanel();
	private JTextField eUser;
	private JTextField eKey;
	private JSpinner ePassLen;
    private JSpinner eInterval;
    private JComboBox<String> cHash;
    private JCheckBox cTime;
    private JSpinner eTime;
    private JTextField ePassword;
    private JTextField eCount;
    private JTextField eUserV;
    private JTextField ePasswordV;
    private JSpinner eDeltaV;
    private JCheckBox cTimeV;
    private JSpinner eTimeV;
    JLabel lRes;
	JButton bGenerate;
    JButton bAdd;
    JButton bClear;
    JButton bValid;

    TElOTPUserStorage Storage;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			Main dialog = new Main();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			showErrorMessage(e.getMessage());
		}
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
        #error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
        SBUtils.setLicenseKey("<put the key here>");

        Storage = new TElOTPUserStorage();

		setTitle("Demo TOTP");
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width - 645) / 2, (screenSize.height - 540) / 2, 645, 540);

		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JPanel panelTop = new JPanel();
        panelTop.setBorder(new TitledBorder(null, "Parameters for generate password/User  ", TitledBorder.LEADING, TitledBorder.TOP, null, null));
        panelTop.setBounds(10, 10, 610, 235);
		contentPanel.add(panelTop);
        panelTop.setLayout(null);
		
		JLabel lblNewLabel = new JLabel("User ID:");
		lblNewLabel.setBounds(211, 33, 50, 15);
        panelTop.add(lblNewLabel);
		{
			eUser = new JTextField();
            eUser.setBounds(277, 30, 123, 21);
            panelTop.add(eUser);
		}

		JLabel lblNewLabel_1 = new JLabel("Key:");
		lblNewLabel_1.setBounds(234, 68, 30, 15);
        panelTop.add(lblNewLabel_1);
		{
			eKey = new JTextField();
            eKey.setBounds(277, 65, 202, 21);
            panelTop.add(eKey);
		}

        JLabel lblNewLabel_2 = new JLabel("Password length:");
        lblNewLabel_2.setBounds(154, 103, 101, 15);
        panelTop.add(lblNewLabel_2);
        {
            SpinnerModel modelLen = new SpinnerNumberModel(0, 0, 10, 1);
            ePassLen = new JSpinner(modelLen);
            ePassLen.setBounds(277, 100, 60, 21);
            panelTop.add(ePassLen);
        }

        JLabel lblNewLabel_3 = new JLabel("Time interval:");
        lblNewLabel_3.setBounds(177, 138, 80, 15);
        panelTop.add(lblNewLabel_3);
        {
            SpinnerModel modelC = new SpinnerNumberModel(30, 0, 999, 1);
            eInterval = new JSpinner(modelC);
            eInterval.setBounds(277, 135, 60, 21);
            panelTop.add(eInterval);
        }

        JLabel lblNewLabel_4 = new JLabel("Hash algorithm:");
        lblNewLabel_4.setBounds(163, 173, 94, 15);
        panelTop.add(lblNewLabel_4);
        {
            cHash = new JComboBox<String>();
            cHash.setBounds(277, 170, 123, 23);
            cHash.setModel(new DefaultComboBoxModel<String>(new String[] {"SHA-1 (default)", "SHA-256", "SHA-512"}));
            panelTop.add(cHash);
        }

        cTime = new JCheckBox("Use this time");
        cTime.setBounds(160, 206, 105, 19);
        panelTop.add(cTime);
        {
            Calendar cal = Calendar.getInstance();
            SpinnerModel modelT = new SpinnerDateModel(cal.getTime(), null, null, Calendar.MONTH);
            eTime = new JSpinner(modelT);
            JSpinner.DateEditor de = new JSpinner.DateEditor(eTime, "dd.MM.yyyy HH:mm:ss");
            eTime.setEditor(de);
            eTime.setBounds(279, 205, 161, 21);
            panelTop.add(eTime);
        }

        bGenerate = new JButton("Generate password");
        bGenerate.setBounds(10, 255, 160, 25);
        bGenerate.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                if (eKey.getText().length() == 0)
                    showErrorMessage("Empty Key");
                else if (ePassLen.getValue().toString().length() == 0)
                    showErrorMessage("Empty Password length");
                else
                    doGenerate();
            }
        });
        contentPanel.add(bGenerate);

        bGenerate = new JButton("Add user to Storage");
        bGenerate.setBounds(340, 255, 150, 25);
        bGenerate.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                if (eUser.getText().length() == 0)
                    showErrorMessage("Empty User ID");
                else if (eKey.getText().length() == 0)
                    showErrorMessage("Empty Key");
                else if (ePassLen.getValue().toString().length() == 0)
                    showErrorMessage("Empty Password length");
                else
                    doAdd();
            }
        });
        contentPanel.add(bGenerate);

        bGenerate = new JButton("Clear Storage");
        bGenerate.setBounds(503, 255, 115, 25);
        bGenerate.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                Storage.clear();
                eCount.setText(Integer.toString(Storage.getCount()));
            }
        });
        contentPanel.add(bGenerate);

        JLabel lblNewLabel_5 = new JLabel("Generated password:");
        lblNewLabel_5.setBounds(10, 293, 124, 15);
        contentPanel.add(lblNewLabel_5);
        {
            ePassword = new JTextField();
            ePassword.setBounds(157, 290, 141, 21);
            ePassword.setEditable(false);
            contentPanel.add(ePassword);
        }

        JLabel lblNewLabel_6 = new JLabel("Users in Storage:");
        lblNewLabel_6.setBounds(442, 293, 105, 15);
        contentPanel.add(lblNewLabel_6);
        {
            eCount = new JTextField();
            eCount.setBounds(565, 290, 52, 21);
            eCount.setText("0");
            eCount.setEditable(false);
            contentPanel.add(eCount);
        }

        JPanel panelBottom = new JPanel();
        panelBottom.setBorder(new TitledBorder(null, "Password check  ", TitledBorder.LEADING, TitledBorder.TOP, null, null));
        panelBottom.setBounds(10, 320, 610, 175);
        contentPanel.add(panelBottom);
        panelBottom.setLayout(null);

        JLabel lblNewLabel_7 = new JLabel("User ID:");
        lblNewLabel_7.setBounds(67, 35, 51, 15);
        panelBottom.add(lblNewLabel_7);
        {
            eUserV = new JTextField();
            eUserV.setBounds(133, 32, 123, 21);
            panelBottom.add(eUserV);
        }

        JLabel lblNewLabel_8 = new JLabel("Password:");
        lblNewLabel_8.setBounds(53, 70, 64, 15);
        panelBottom.add(lblNewLabel_8);
        {
            ePasswordV = new JTextField();
            ePasswordV.setBounds(133, 67, 155, 21);
            panelBottom.add(ePasswordV);
        }

        JLabel lblNewLabel_9 = new JLabel("Delta:");
        lblNewLabel_9.setBounds(81, 105, 39, 15);
        panelBottom.add(lblNewLabel_9);
        {
            SpinnerModel modelC = new SpinnerNumberModel(0, 0, 20, 1);
            eDeltaV = new JSpinner(modelC);
            eDeltaV.setBounds(133, 103, 60, 21);
            panelBottom.add(eDeltaV);
        }

        cTimeV = new JCheckBox("Use this time");
        cTimeV.setBounds(10, 141, 105, 19);
        panelBottom.add(cTimeV);
        {
            Calendar cal = Calendar.getInstance();
            SpinnerModel modelTV = new SpinnerDateModel(cal.getTime(), null, null, Calendar.MONTH);
            eTimeV = new JSpinner(modelTV);
            JSpinner.DateEditor de = new JSpinner.DateEditor(eTimeV, "dd.MM.yyyy HH:mm:ss");
            eTimeV.setEditor(de);
            eTimeV.setBounds(133, 140, 161, 21);
            panelBottom.add(eTimeV);
        }

        bValid = new JButton("Is password valid");
        bValid.setBounds(444, 30, 150, 25);
        bValid.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                if (eUserV.getText().length() == 0)
                    showErrorMessage("Empty User ID");
                else if (ePasswordV.getText().length() == 0)
                    showErrorMessage("Empty password");
                else
                    doValid();
            }
        });
        panelBottom.add(bValid);

        lRes = new JLabel("");
        lRes.setBounds(444, 72, 150, 31);
        lRes.setHorizontalAlignment(SwingConstants.CENTER);
        lRes.setFont(new Font("Serif", Font.PLAIN, 24));
        panelBottom.add(lRes);
	}

    protected void doGenerate()
    {
        byte[] KeySecret = SBUtils.bytesOfString(eKey.getText());
        int PasswordLen = (Integer)ePassLen.getValue();

        TElTOTPClient TOTPClient = new TElTOTPClient(KeySecret, PasswordLen);
        try
        {
            TOTPClient.setTimeInterval((Integer)eInterval.getValue());

            switch (cHash.getSelectedIndex())
            {
                case 1:
                    TOTPClient.setHashAlgorithm(SBConstants.SB_ALGORITHM_MAC_HMACSHA256);
                    break;
                case 2:
                    TOTPClient.setHashAlgorithm(SBConstants.SB_ALGORITHM_MAC_HMACSHA512);
                    break;
            }


            try
            {
                if (cTime.isSelected())
                {
                    SimpleDateFormat format = new SimpleDateFormat("dd.MM.yyyy HH:mm:ss");
                    format.setTimeZone(new SimpleTimeZone(SimpleTimeZone.UTC_TIME, "UTC"));
                    Date date = format.parse(new SimpleDateFormat("dd.MM.yyyy HH:mm:ss").format((Date)eTime.getValue()));

                    ePassword.setText(TOTPClient.getPassword(date));
                }
                else
                {
                    ePassword.setText(TOTPClient.getPassword());
                }
            }
            catch (Exception e)
            {
                showErrorMessage(e.getMessage());
            }
        }
        finally
        {
            TOTPClient.Free();
        }
    }

    protected void doAdd()
    {
        TElTOTPUser User = new TElTOTPUser();
        try
        {
            User.setUserID(eUser.getText());
            User.setKeySecret(SBUtils.bytesOfString(eKey.getText()));
            User.setPasswordLen((Integer)ePassLen.getValue());
            User.setTimeInterval((Integer)eInterval.getValue());

            switch (cHash.getSelectedIndex())
            {
                case 1:
                    User.setHashAlgorithm(SBConstants.SB_ALGORITHM_MAC_HMACSHA256);
                    break;
                case 2:
                    User.setHashAlgorithm(SBConstants.SB_ALGORITHM_MAC_HMACSHA512);
                    break;
            }

            Storage.add(User);
            eCount.setText(Integer.toString(Storage.getCount()));
        }
        finally
        {
            User.Free();
        }
    }

    protected void doValid()
    {
        TElTOTPServer TOTPServer = new TElTOTPServer(Storage);
        try
        {
            if ((Integer)eDeltaV.getValue() != 0)
            {
                TOTPServer.setDelta((Integer)eDeltaV.getValue());
            }

            try
            {
                boolean Res = false;

                if (cTimeV.isSelected())
                {
                    SimpleDateFormat format = new SimpleDateFormat("dd.MM.yyyy HH:mm:ss");
                    format.setTimeZone(new SimpleTimeZone(SimpleTimeZone.UTC_TIME, "UTC"));
                    Date date = format.parse(new SimpleDateFormat("dd.MM.yyyy HH:mm:ss").format((Date)eTimeV.getValue()));

                    Res = TOTPServer.isPasswordValid(eUserV.getText(), ePasswordV.getText(), date);
                }
                else
                {
                    Res = TOTPServer.isPasswordValid(eUserV.getText(), ePasswordV.getText());
                }


                if (Res)
                {
                    lRes.setText("Valid");
                    lRes.setForeground(Color.GREEN);
                }
                else
                {
                    lRes.setText("Not Valid");
                    lRes.setForeground(Color.RED);
                }
            }
            catch (Exception e)
            {
                lRes.setText("Error");
                lRes.setForeground(Color.RED);
                showErrorMessage(e.getMessage());
            }
        }
        finally
        {
            TOTPServer.Free();
        }
    }

    static void showErrorMessage(String msg){
        JOptionPane.showMessageDialog(null, msg, "Error", JOptionPane.ERROR_MESSAGE);
    }

    public void actionPerformed(ActionEvent e) {

    }


}
