import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JTabbedPane;

import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JProgressBar;

import org.freepascal.rtl.TObject;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;

import SecureBlackbox.Base.*;
import SecureBlackbox.HTTPClient.*;

public class Main extends JDialog {

	private static final long serialVersionUID = 1L;
	
	private JFrame frmRfcDemo;
	private JTextField textServerURL;
	private JTextField textInputFile;
	private JTextField textTimestampFile;
	private JTextField textTimestampedFile;
	private JTextField textOriginalFile;
	private JTextField textOutputFile;
	
	private boolean fDetached, fFirst = true;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main window = new Main();
					window.frmRfcDemo.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public Main() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
	
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmRfcDemo = new JFrame();
		frmRfcDemo.setTitle("RFC5544 demo");
		frmRfcDemo.setBounds(100, 100, 408, 361);
		frmRfcDemo.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmRfcDemo.getContentPane().setLayout(null);
		
		JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.TOP);
		tabbedPane.setBounds(0, 0, 392, 329);
		frmRfcDemo.getContentPane().add(tabbedPane);
		
		JPanel panel = new JPanel();
		tabbedPane.addTab("Timestamp", null, panel, null);
		panel.setLayout(null);
		
		JLabel lblNewLabel = new JLabel("TSP server URL:");
		lblNewLabel.setBounds(10, 11, 151, 14);
		panel.add(lblNewLabel);
		
		textServerURL = new JTextField();
		textServerURL.setBounds(10, 32, 368, 20);
		panel.add(textServerURL);
		textServerURL.setColumns(10);
		
		JLabel lblFileToTimestamp = new JLabel("File to timestamp:");
		lblFileToTimestamp.setBounds(10, 63, 175, 14);
		panel.add(lblFileToTimestamp);
		
		textInputFile = new JTextField();
		textInputFile.setColumns(10);
		textInputFile.setBounds(10, 84, 276, 20);
		panel.add(textInputFile);
		
		JLabel lblOutputFile = new JLabel("Output file:");
		lblOutputFile.setBounds(10, 118, 200, 14);
		panel.add(lblOutputFile);
		
		textTimestampFile = new JTextField();
		textTimestampFile.setColumns(10);
		textTimestampFile.setBounds(10, 139, 276, 20);
		panel.add(textTimestampFile);
		
		JButton btnChoose1 = new JButton("Choose");
		btnChoose1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				textInputFile.setText(chooseOpenFileName());
			}
		});
		btnChoose1.setBounds(289, 83, 89, 23);
		panel.add(btnChoose1);
		
		JButton btnChoose2 = new JButton("Choose");
		btnChoose2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				textTimestampFile.setText(chooseOpenFileName());
			}
		});
		btnChoose2.setBounds(289, 138, 89, 23);
		panel.add(btnChoose2);
		
		final JCheckBox cbIncludeContent = new JCheckBox("Include file content to output (create non-detached timestamp)");
		cbIncludeContent.setBounds(10, 180, 368, 23);
		panel.add(cbIncludeContent);
		
		final JProgressBar progressBar1 = new JProgressBar();
		progressBar1.setBounds(10, 220, 368, 14);
		panel.add(progressBar1);
		
		JPanel panel_1 = new JPanel();
		tabbedPane.addTab("Verify", null, panel_1, null);
		panel_1.setLayout(null);
		
		JLabel lblFileWithTimestamp = new JLabel("File with timestamp:");
		lblFileWithTimestamp.setBounds(10, 11, 175, 14);
		panel_1.add(lblFileWithTimestamp);
		
		textTimestampedFile = new JTextField();
		textTimestampedFile.setColumns(10);
		textTimestampedFile.setBounds(10, 32, 276, 20);
		panel_1.add(textTimestampedFile);
		
		final JButton btnChoose4 = new JButton("Choose");
		btnChoose4.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				textOriginalFile.setText(chooseOpenFileName());
			}
		});
		btnChoose4.setBounds(289, 83, 89, 23);
		panel_1.add(btnChoose4);
		
		final JButton btnChoose5 = new JButton("Choose");
		btnChoose5.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				textOutputFile.setText(chooseSaveFileName());
			}
		});
		btnChoose5.setBounds(289, 135, 89, 23);
		panel_1.add(btnChoose5);
		
		JButton btnChoose3 = new JButton("Choose");
		btnChoose3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String file = chooseOpenFileName();
				textTimestampedFile.setText(file);
				
				if (file.length() == 0)
					return;
				
				TElFileStream fsi = new TElFileStream(file, SBStreams.fmOpenRead);
				try {
					TSBString dataURI = new TSBString(), fileName = new TSBString();
					fDetached = TElMessageTimestampVerifier.isTimestampDetached(fsi, dataURI, fileName, 0);
					
					if (fDetached) {
						textOutputFile.setEnabled(false);
						btnChoose5.setEnabled(false);
						textOriginalFile.setEnabled(true);
						btnChoose4.setEnabled(true);
					} else {
						textOutputFile.setEnabled(true);
						btnChoose5.setEnabled(true);
						textOriginalFile.setEnabled(false);
						btnChoose4.setEnabled(false);
					}
				} finally {
					fsi.Free();
				}
			}
		});
		btnChoose3.setBounds(289, 31, 89, 23);
		panel_1.add(btnChoose3);
		
		JLabel lblOriginalFilefor = new JLabel("Original file (for detached timestamps):");
		lblOriginalFilefor.setBounds(10, 63, 282, 14);
		panel_1.add(lblOriginalFilefor);
		
		textOriginalFile = new JTextField();
		textOriginalFile.setColumns(10);
		textOriginalFile.setBounds(10, 84, 276, 20);
		panel_1.add(textOriginalFile);
		
		JLabel lblOutputFilefor = new JLabel("Output file (for non-detached timestamps):");
		lblOutputFilefor.setBounds(10, 115, 297, 14);
		panel_1.add(lblOutputFilefor);
		
		textOutputFile = new JTextField();
		textOutputFile.setColumns(10);
		textOutputFile.setBounds(10, 136, 276, 20);
		panel_1.add(textOutputFile);
		
		JButton btnVerify = new JButton("Verify timestamp");
		btnVerify.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				TElMessageTimestampVerifier verifier = new TElMessageTimestampVerifier();
				
				TElFileStream fsi = new TElFileStream(textTimestampedFile.getText(), SBStreams.fmOpenRead);
				TElFileStream ts = null;
				int err;
				
				try {
					if (fDetached) {
						ts = new TElFileStream(textOriginalFile.getText(), SBStreams.fmOpenRead);
						try {
							err = verifier.verifyDetached(fsi, ts, 0, 0);
						} finally {
							ts.Free();
						}
					} else {
						ts = new TElFileStream(textOutputFile.getText(), (byte)(SBStreams.fmCreate | SBStreams.fmOpenReadWrite));
						try {
							err = verifier.verify(fsi, ts, 0);
						} finally {
							ts.Free();
						}
					}
					
					fFirst = true;
					if (err != 0)
						JOptionPane.showMessageDialog(null, "Verification error " + err, "Error", JOptionPane.ERROR_MESSAGE);
					else
						JOptionPane.showMessageDialog(null, "Timestamp is valid!", "Result", JOptionPane.INFORMATION_MESSAGE);
				} finally {
					fsi.Free();
				}
			}
		});
		btnVerify.setBounds(128, 204, 158, 23);
		panel_1.add(btnVerify);
		
		JButton btnCreate = new JButton("Create timestamp");
		btnCreate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				progressBar1.setValue(0);
				
				TElMessageTimestamper timestamper = new TElMessageTimestamper();
	            TElHTTPTSPClient tspClient = new TElHTTPTSPClient();
	            TElHTTPSClient httpClient = new TElHTTPSClient();
	            
	            tspClient.setURL(textServerURL.getText());
	            tspClient.setHTTPClient(httpClient);
	            
	            timestamper.setTSPClient(tspClient);
	            timestamper.setIncludeContent(cbIncludeContent.isSelected());
	            timestamper.setFileName(new File(textInputFile.getText()).getName());
	            
	            timestamper.setOnProgress(new TSBProgressEvent(new TSBProgressEvent.Callback() {
					@Override
					public void tsbProgressEventCallback(TObject sender, long total, long current, TSBBoolean cancel) {
						if (fFirst) {
							progressBar1.setMaximum((int)total);
							fFirst = false;
						}
						
						progressBar1.setValue((int)current);
						cancel.value = false;
					}
				}));
	            
	            TElFileStream fsi = new TElFileStream(textInputFile.getText(), SBStreams.fmOpenRead);
	            try {
	            	TElFileStream fso = new TElFileStream(textTimestampFile.getText(), SBStreams.fmCreate);
		            try {
		            	int err = timestamper.timestamp(fsi, fso, 0);
		            	
		            	fFirst = true;
		            	if (err != 0) {
		            		JOptionPane.showMessageDialog(null, "Timestamping error " + err, "Error", JOptionPane.ERROR_MESSAGE);
		            		return;
		            	}
		            } finally {
		            	fsi.Free();
		            }
	            } finally {
	            	fsi.Free();
	            }
			}
		});
		btnCreate.setBounds(114, 251, 172, 23);
		panel.add(btnCreate);
	}
	
	private String chooseOpenFileName() {
		JFileChooser fc = new JFileChooser();
		fc.setDialogTitle("Select file");

		if (fc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	private String chooseSaveFileName(){
		JFileChooser fc = new JFileChooser();
		fc.setDialogTitle("Select file");

		if (fc.showSaveDialog(this) == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

		return "";
	} 
}
