

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.SSHClient.*;
import SecureBlackbox.SSHCommon.*;

public class Main {

    static TElSimpleSSHClient Client = null;

    static String parCommand;
    static String parUsername;
    static String parPassword;
    static String parAddress;
    static int parPort;
	
	public static void main(String[] args) {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");

        parPort = 22;

        if (!ParseCommandLine(args))
            return;

        Client = new TElSimpleSSHClient();
        Client.setAddress(parAddress);
        Client.setPort(parPort);

        Client.setUsername(parUsername);
        Client.setPassword(parPassword);

        Client.setOnKeyValidate(new TSSHKeyValidateEvent(OnKeyValidate));


        try
        {
            byte[] resp = Client.executeCommand(parCommand);
            String output = new String(resp);
            System.out.print(output);
        }
        catch (Exception e)
        {
            System.out.println("Connection failed due to exception: " + e.getMessage());
            System.out.println("If you have ensured that all connection parameters are correct and you still can't connect,");
            System.out.println("please contact EldoS support as described on http://www.eldos.com/sbb/support-tech.php");
            System.out.println("Remember to provide details about the error that happened.");
            if (Client.getServerSoftwareName().length() > 0)
            {
                System.out.println("Server software identified itself as: " + Client.getServerSoftwareName());
            }
        }
	}

	static TSSHKeyValidateEvent.Callback OnKeyValidate = new TSSHKeyValidateEvent.Callback() {
		
		public void tsshKeyValidateEventCallback(TObject arg0, TElSSHKey arg1, TSBBoolean accept) {
	        System.out.println("Server key received");
			accept.value = true; // NEVER do this. You MUST check the key validity somehow
		}
	};
	
    static boolean ParseCommandLine(String[] args)
    {
        int i = 0;
        String arg;

        if (args.length == 0)
        {
            System.out.println("usage:");
            System.out.println("ConsoleSSH -addr[ess] <address> [-port <port>] -user[name] <user> -pass[word] <password> -command <command to execute remotely>");
            return false;
        }
        else
        {
            while (i < args.length)
            {
                arg = args[i];
                if (arg.compareTo("-command") == 0)
                {
                    i++;
                    parCommand = args[i];
                }
                else if ((arg.compareTo("-addr") == 0) ||
                  (arg.compareTo("-address") == 0))
                {
                    i++;
                    parAddress = args[i];
                }
                else if (arg.compareTo("-port") == 0)
                {
                    i++;
                    try
                    {
                        parPort = Integer.parseInt(args[i]);
                    }
                    catch (Exception ex)
                    {
                        parPort = 22;
                    }
                }
                else if ((arg.compareTo("-user") == 0) ||
                    (arg.compareTo("-username") == 0))
                {
                    i++;
                    parUsername = args[i];
                }
                else if ((arg.compareTo("-pass") == 0) ||
                    (arg.compareTo("-password") == 0))
                {
                    i++;
                    parPassword = args[i];
                }
                i = i + 1;
            }
            return (parCommand != "");
        }
    }
}
