import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.JLabel;
import javax.swing.JPasswordField;

public class PasswordDialog extends JDialog implements ActionListener {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JPasswordField tbPass;
	private JPasswordField tbPassCnfrm;
	private JButton okButton;
	private boolean isOk;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			PasswordDialog dialog = new PasswordDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public PasswordDialog() {
		setTitle("Set password");
		setBounds(100, 100, 346, 179);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JLabel lblEnterPasswordFor = new JLabel("Enter new password for user:");
			lblEnterPasswordFor.setBounds(10, 11, 273, 14);
			contentPanel.add(lblEnterPasswordFor);
		}
		{
			tbPass = new JPasswordField();
			tbPass.setBounds(10, 33, 310, 20);
			contentPanel.add(tbPass);
			tbPass.setColumns(10);
		}
		{
			JLabel lblPasswordConfirmation = new JLabel("Password confirmation:");
			lblPasswordConfirmation.setBounds(10, 64, 227, 14);
			contentPanel.add(lblPasswordConfirmation);
		}
		{
			tbPassCnfrm = new JPasswordField();
			tbPassCnfrm.setBounds(10, 88, 310, 20);
			contentPanel.add(tbPassCnfrm);
			tbPassCnfrm.setColumns(10);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setEnabled(false);
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = false;
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		
		addPasswordDocumentLisner(tbPass, this);
		addPasswordDocumentLisner(tbPassCnfrm, this);
	}

	public void actionPerformed(ActionEvent e) {
		okButton.setEnabled((new String(tbPass.getPassword()).compareTo(new String(tbPassCnfrm.getPassword())) == 0)
				&& (tbPass.getPassword().length > 0));		
	}

	public void addPasswordDocumentLisner(final JPasswordField txt, final ActionListener l) {
		txt.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				l.actionPerformed(new ActionEvent(txt, 0, "changed"));
			}

			public void insertUpdate(DocumentEvent arg0) {
				l.actionPerformed(new ActionEvent(txt, 1, "insert"));
			}

			public void removeUpdate(DocumentEvent e) {			
				l.actionPerformed(new ActionEvent(txt, 2, "remove"));
			}
		});
	}
	
    public static String GetPassword()
    {
        PasswordDialog frm = new PasswordDialog();
        frm.setModal(true);
        frm.setVisible(true);
        
        String Pwd = null;
        
		if (frm.isOK())
        {
            Pwd = new String(frm.tbPass.getPassword());
			frm.dispose();
        }
		return Pwd;
    }

	private boolean isOK() {
		return isOk;
	}
}
