import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.Dimension;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JCheckBox;
import javax.swing.border.TitledBorder;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class ConnectionDialog extends JDialog {
	
	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField txtHost;
	private JTextField txtPort;
	protected boolean isOk;
	private JCheckBox cbSSLEnabled;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			ConnectionDialog dialog = new ConnectionDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public ConnectionDialog() {
		setTitle("Connection properties");
		setSize(new Dimension(360, 150));
		setBounds(100, 100, 360, 205);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "Connection properties", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 11, 332, 125);
		contentPanel.add(panel);
		panel.setLayout(null);
		
		JLabel lblHost = new JLabel("Host");
		lblHost.setBounds(10, 24, 46, 14);
		panel.add(lblHost);
		
		JLabel lblPort = new JLabel("Port");
		lblPort.setBounds(213, 24, 46, 14);
		panel.add(lblPort);
		
		txtHost = new JTextField();
		txtHost.setText("www.microsoft.com");
		txtHost.setBounds(13, 49, 190, 20);
		panel.add(txtHost);
		txtHost.setColumns(10);
		
		txtPort = new JTextField();
		txtPort.setText("443");
		txtPort.setBounds(213, 49, 86, 20);
		panel.add(txtPort);
		txtPort.setColumns(10);
		
		cbSSLEnabled = new JCheckBox("SSL enabled");
		cbSSLEnabled.setSelected(true);
		cbSSLEnabled.setBounds(10, 76, 97, 23);
		panel.add(cbSSLEnabled);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						setVisible(false);
						isOk = true;
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	public boolean isOk() {
		return isOk;
	}

	public String getHost() {
		return txtHost.getText();
	}

	public String getPort() {
		return txtPort.getText();
	}

	public boolean getSSLEnabled() {
		return cbSSLEnabled.isSelected();
	}
}